
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NonconformancesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.create(
            {
                id: data.id || undefined,
        
        ncr_number: data.ncr_number
        ||
        null
            ,
            
        source: data.source
        ||
        null
            ,
            
        severity: data.severity
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        reported_at: data.reported_at
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        containment_action: data.containment_action
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await nonconformances.setMaterial( data.material || null, {
            transaction,
        });
        
        await nonconformances.setLot( data.lot || null, {
            transaction,
        });
        
        await nonconformances.setProduction_lot( data.production_lot || null, {
            transaction,
        });
        
        await nonconformances.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await nonconformances.setMachine( data.machine || null, {
            transaction,
        });
        
        await nonconformances.setReported_by( data.reported_by || null, {
            transaction,
        });
        
        await nonconformances.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: nonconformances.id,
            },
            data.evidence_files,
            options,
        );
        

        return nonconformances;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const nonconformancesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                ncr_number: item.ncr_number
            ||
            null
            ,
            
                source: item.source
            ||
            null
            ,
            
                severity: item.severity
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                reported_at: item.reported_at
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                containment_action: item.containment_action
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const nonconformances = await db.nonconformances.bulkCreate(nonconformancesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < nonconformances.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.nonconformances.getTableName(),
                    belongsToColumn: 'evidence_files',
                    belongsToId: nonconformances[i].id,
                },
                data[i].evidence_files,
                options,
            );
        }
        

        return nonconformances;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const nonconformances = await db.nonconformances.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.ncr_number !== undefined) updatePayload.ncr_number = data.ncr_number;
        
        
        if (data.source !== undefined) updatePayload.source = data.source;
        
        
        if (data.severity !== undefined) updatePayload.severity = data.severity;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.reported_at !== undefined) updatePayload.reported_at = data.reported_at;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.containment_action !== undefined) updatePayload.containment_action = data.containment_action;
        
        
        updatePayload.updatedById = currentUser.id;

        await nonconformances.update(updatePayload, {transaction});

        
        
        if (data.material !== undefined) {
            await nonconformances.setMaterial(
              
              data.material,
              
              { transaction }
            );
        }
        
        if (data.lot !== undefined) {
            await nonconformances.setLot(
              
              data.lot,
              
              { transaction }
            );
        }
        
        if (data.production_lot !== undefined) {
            await nonconformances.setProduction_lot(
              
              data.production_lot,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await nonconformances.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.machine !== undefined) {
            await nonconformances.setMachine(
              
              data.machine,
              
              { transaction }
            );
        }
        
        if (data.reported_by !== undefined) {
            await nonconformances.setReported_by(
              
              data.reported_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await nonconformances.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.nonconformances.getTableName(),
                belongsToColumn: 'evidence_files',
                belongsToId: nonconformances.id,
            },
            data.evidence_files,
            options,
        );
        

        return nonconformances;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of nonconformances) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of nonconformances) {
                await record.destroy({transaction});
            }
        });


        return nonconformances;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findByPk(id, options);

        await nonconformances.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await nonconformances.destroy({
            transaction
        });

        return nonconformances;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const nonconformances = await db.nonconformances.findOne(
            { where },
            { transaction },
        );

        if (!nonconformances) {
            return nonconformances;
        }

        const output = nonconformances.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.dispositions_nonconformance = await nonconformances.getDispositions_nonconformance({
            transaction
        });
        
        
        output.corrective_actions_nonconformance = await nonconformances.getCorrective_actions_nonconformance({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.material = await nonconformances.getMaterial({
            transaction
        });
        
        
        output.lot = await nonconformances.getLot({
            transaction
        });
        
        
        output.production_lot = await nonconformances.getProduction_lot({
            transaction
        });
        
        
        output.production_order = await nonconformances.getProduction_order({
            transaction
        });
        
        
        output.machine = await nonconformances.getMachine({
            transaction
        });
        
        
        output.reported_by = await nonconformances.getReported_by({
            transaction
        });
        
        
        output.evidence_files = await nonconformances.getEvidence_files({
            transaction
        });
        
        
        output.organizations = await nonconformances.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.materials,
        as: 'material',
        
        where: filter.material ? {
          [Op.or]: [
            { id: { [Op.in]: filter.material.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.material.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lots,
        as: 'lot',
        
        where: filter.lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_lots,
        as: 'production_lot',
        
        where: filter.production_lot ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_lot.split('|').map(term => Utils.uuid(term)) } },
            {
              lot_number: {
                [Op.or]: filter.production_lot.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.machines,
        as: 'machine',
        
        where: filter.machine ? {
          [Op.or]: [
            { id: { [Op.in]: filter.machine.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.machine.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reported_by',
        
        where: filter.reported_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reported_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reported_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'evidence_files',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.ncr_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        filter.ncr_number,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'description',
                        filter.description,
                    ),
                };
            }
            
            if (filter.containment_action) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'nonconformances',
                        'containment_action',
                        filter.containment_action,
                    ),
                };
            }
            

            
            

            
            if (filter.reported_atRange) {
                const [start, end] = filter.reported_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reported_at: {
                    ...where.reported_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.source) {
                where = {
                    ...where,
                source: filter.source,
            };
            }
            
            if (filter.severity) {
                where = {
                    ...where,
                severity: filter.severity,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.nonconformances.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'nonconformances',
                        'ncr_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.nonconformances.findAll({
            attributes: [ 'id', 'ncr_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['ncr_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.ncr_number,
        }));
    }

    
};

